/*! ********************************************
 * GBEvent.as
 * Copyright 2019 masahiro takamoto (MotChan)
 * Distributed under the MIT license. 
 * see -> sora/license.txt
 ******************************************** */
package sora.graybox.event 
{
import flash.events.Event;
import flash.utils.ByteArray;
import sora.graybox.IGrayBoxModule;
import sora.graybox.MidiEvent;

public class GBEvent extends Event 
{
	static public const MIDI_CHANNEL_MESSAGE:String = "midiChannelMessage";
	static public const MIDI_SYSTEM_MESSAGE	:String = "midiSystemMessage";
	static public const SMF_META_MESSAGE	:String = "smfMetaMessage";
	
	internal var fr:int = 0;
	internal var next:GBEvent = null;
	
	public var messageType :int = 0;
	public var channel     :int = 0;
	public var value0      :int = 0;
	public var value1      :int = 0;
	
	public var data		:ByteArray = null;
	//public var dataSize		:int = 0;
	
// Constructor
	public function GBEvent(type:String, bubbles:Boolean=false, cancelable:Boolean=false):void 
	{ 
		super(type, bubbles, cancelable);
	} 
	
	public override function clone():Event 
	{ 
		var _event:GBEvent = new GBEvent(type, bubbles, cancelable);
		_event.messageType = messageType;
		_event.channel = channel;
		_event.value0 = value0;
		_event.value1 = value1;
		_event.data = data;
		return _event;
	} 
	
	public override function toString():String 
	{ 
		return formatToString("GBMIDIEvent", "type", "bubbles", "cancelable", "eventPhase"); 
	}
}
}