/*! ********************************************
 * TonePresetFM.as
 * Copyright 2019 masahiro takamoto (MotChan)
 * Distributed under the MIT license. 
 * see -> sora/license.txt
 ******************************************** */
package sora.graybox.synth
{
public class TonePresetFM
{
// Inastance -----
	public var toneName		:String = "  default preset";
	public var key			:int = 64;   // 0 - 127     *Percussion
	public var pan			:int = 64;   // 0 - 127     *Percussion
	public var lfoWave		:int = 0;    // 0 - 3
	public var lfoFreq		:int = 2048; // 0 - 16383   LFO - Phase Update Timer Parameter
	public var fl			:int = 127;  // 0 - 127     Feed Back Level
	public var strc			:int = 0;    // 0 - 7	    strcture
	// operator 0
	//public var velCurve_0	:int;
	public var tlVelCtrl_0	:int = 0;   // 0 - 7        Total Level Contorol - Velocity   Senstivity
	public var mul_0		:int = 1;   // 0 - 7        Multiple       [0] = 1/2 Cycle, [1] = 1/1, [2] = 2/1, [3] = 3/1...
	public var tune_0		:int = 8192;// 0 - 16383    center 8192, octave = 8192
	public var lms_0		:int = 0;   // 0 - 15       LFO - Modulation Depth Senstivity
	public var wave_0		:int = 0;   // 0 - 7
	public var tl_0			:int = 0;   // 0 - 127
	public var ar_0			:int = 124; // 0 - 127
	public var dr_0			:int = 100; // 0 - 127
	public var sl_0			:int = 0;   // 0 - 127
	public var rr_0			:int = 120; // 0 - 127
	public var kf_0			:int = 0;   // 0 - 3        Key Follow Sensitivity         *Instrument 
	public var kfStart_0	:int = 48;  // 0 - 127      Key Number - Start Key Follow  *Instrument
	// operator 1
	//public var velCurve_1	:int;
	public var tlVelCtrl_1	:int = 0;   // 0 - 7
	public var mul_1		:int = 1;   // 0 - 7
	public var tune_1		:int = 8192;// 0 - 16383
	public var lms_1		:int = 0;   // 0 - 15       LFO - Modulation Depth Senstivity
	public var wave_1		:int = 0;   // 0 - 7
	public var tl_1			:int = 0;   // 0 - 127
	public var ar_1			:int = 124; // 0 - 127
	public var dr_1			:int = 100; // 0 - 127
	public var sl_1			:int = 0;   // 0 - 127
	public var rr_1			:int = 120; // 0 - 127
	public var kf_1			:int = 0;   // 0 - 3
	public var kfStart_1	:int = 48;  // 0 - 127
	
// Method
	public function copy(preset:TonePresetFM):void
	{
		toneName = preset.toneName;
		key = preset.key;
		pan = preset.pan;
		lfoWave = preset.lfoWave;
		lfoFreq = preset.lfoFreq;		
		fl = preset.fl;
		strc = preset.strc;
		// operator 0
		tlVelCtrl_0	= preset.tlVelCtrl_0;
		mul_0		= preset.mul_0;
		tune_0		= preset.tune_0;
		lms_0		= preset.lms_0;
		wave_0		= preset.wave_0;
		tl_0		= preset.tl_0;
		ar_0		= preset.ar_0;
		dr_0		= preset.dr_0;
		sl_0		= preset.sl_0;
		rr_0		= preset.rr_0;
		kf_0		= preset.kf_0;
		kfStart_0	= preset.kfStart_0;
		// operator 1
		tlVelCtrl_1	= preset.tlVelCtrl_1;
		mul_1		= preset.mul_1;
		tune_1		= preset.tune_1;
		lms_1		= preset.lms_1;
		wave_1		= preset.wave_1;
		tl_1		= preset.tl_1;
		ar_1		= preset.ar_1;
		dr_1		= preset.dr_1;
		sl_1		= preset.sl_1;
		rr_1		= preset.rr_1;
		kf_1		= preset.kf_1;
		kfStart_1	= preset.kfStart_1;
	}
	public function reset():void
	{
		toneName = "default preset";
		key = 64;
		pan = 64;
		lfoWave = 0;
		lfoFreq = 2048;
		fl = 127;
		strc = 0;
		// operator 0
		tlVelCtrl_0	= 0;
		mul_0		= 1;
		tune_0		= 8192;
		lms_0 		= 0;
		wave_0		= 0;
		tl_0		= 0;
		ar_0		= 124;
		dr_0		= 100;
		sl_0		= 0;
		rr_0		= 120;
		kf_0		= 0;
		kfStart_0	= 48;
		// operator 1
		tlVelCtrl_1	= 0;
		mul_1		= 1;
		tune_1		= 8192;
		lms_1 		= 0;
		wave_1		= 0;
		tl_1		= 0;
		ar_1		= 124;
		dr_1		= 100;
		sl_1		= 0;
		rr_1		= 120;
		kf_1		= 0;
		kfStart_1	= 48;
	}
// Constructor
	public function TonePresetFM():void{}
}
}